﻿/*
# Apprendre à programmer en ActionScript 3
# A. Tasso
# Chapitre 9 : Les principes du concept objet
# Exemple : L'héritage
# Fichier : unSonSurLaPhoto.fla
# Classe :  Personne.as 
*/



//Définition de la classe Personne
package {
	// importer la classe Sprite et Loader
	import flash.display.*;
	// Importer la classe MouseEvent
	import flash.events.*;
	// Pour charger la classe URLRequest
	import flash.net.URLRequest;
	// Importer la classe associée au clip BulleClp
	import BulleClp;


	// Définition de la classe Personne
	public class Personne extends Sprite {
		// Définition des attributs de la classe
		private var prenom:String;
		private var nom:String;
		private var dateNaissance:Date;
		private var photo:Loader;
		private var info:BulleClp;
		
		// Définition de la fonction constructeur 
		public function Personne( p:String, n:String, dn:String) {
			setNom(n);
			setPrenom(p);
			setDateNaissance(dn);
			setPhoto("../Photos/"+p+".jpg");
		}


		// Définition du comportement sePresente()
		public function sePresente():String {
			var age:Number = getAge();
			return "Je m'appelle " + prenom + " " + nom + "\nJ'ai " + age + " ans ";
		}

		public function sAffiche(tmp:Loader):void {
			addChild(tmp);
			tmp.addEventListener(MouseEvent.MOUSE_OVER, auSurvol);
			tmp.addEventListener(MouseEvent.MOUSE_OUT, alExterieur);

			info = new BulleClp();
			// Si la bulle se trouve dans le tiers supérieur droit 
			info.x = 2*tmp.width/3;
			info.y = tmp.height/3;
			// Si les infos s'affichent sous la photo
			// info.x = 0;
			// info.y = tmp.height;

			info.labelOut.text = "Je m'appelle " + getPrenom() + " " + getNom() +"\net j'ai "+ getAge() + " ans";
		}
		private function auSurvol(event:MouseEvent):void {
			addChild(info);
			// Charger les sons de la bibliothèque
			// Supprimer les commentaires des deux lignes suivantes por l'application UnSonSUrLaPhoto.fla
			// var son:Son0 = new Son0();
			// son.play();
		}

		private function alExterieur(event:MouseEvent):void {
			removeChild(info);
		}
		// Définition de la méthode calculant l’âge de la personne
		public function getAge():Number {
			var aujourdHui:Date = new Date();
			var age:Number = 
			    aujourdHui.getFullYear() - dateNaissance.getFullYear();
			return age;
		}

		//  Méthode d’accès en lecture (get)
		//  récupérer le prénom
		public function getPrenom():String {
			return prenom;
		}
		//  récupérer le nom
		public function getNom():String {
			return nom;
		}
		//  récupérer la date de naissance
		public function getDateNaissance():String {
			return dateNaissance.getDate() + "/" + dateNaissance.getMonth() + "/" + dateNaissance.getFullYear();
		}
		//  Méthode d’accès en écriture (set)
		public function setPhoto(url:String):void {
			photo= new Loader();
			photo.load(new URLRequest(url));
			photo.contentLoaderInfo.addEventListener(Event.COMPLETE, auComplet);
			photo.load(new URLRequest(url));
		}
		private function auComplet(evt:Event):void {
			sAffiche(photo);
		}
		//  Modifier le prénom
		public function setPrenom(p:String):void {
			prenom = p;
		}
		// Modifier le nom
		public function setNom(n:String):void {
			nom = n;
		}
		// Modifier la date de naissance apres validation 
		public function setDateNaissance(dn:String):void {
			var tmp:Array=new Array();
			tmp = dn.split("/",3);

			dateNaissance = new Date(tmp[2], tmp[1], tmp[0]);
			if ( ! valideDateNaissance()) {
				dateNaissance = new Date();
			}
		}

		// Méthode invisible (métier) pour vérifier la validité de la date de naissance
		private function valideDateNaissance():Boolean {
			var aujourdHui:Date = new Date();
			var cetteAnnee:Number  = aujourdHui.getFullYear();
			var anneeNaissance:Number = dateNaissance.getFullYear();
			if (cetteAnnee  < anneeNaissance) {
				return false;
			} else {
				return true;
			}

		}
	}
}