﻿/*
# Apprendre à programmer en ActionScript
# A. Tasso
# Chapitre 9 : Les principe du concept objet
# Projet Le mini site 
# Fichier : LecteurVideo.as
*/

package {
	import flash.display.*;
	import flash.events.*;
	import flash.net.*;
	import flash.media.*;
	import flash.geom.Rectangle;
	import flash.net.URLRequest;
	public class LecteurVideo extends Sprite {
		// Le flux vidéo est commun à toutes les classes de l'application
		// pour pouvoir être supprimé à tout moment 
		public static var unFlux:NetStream;
		private var controleur:ControleurClp;
		private var initX:Number;
		private var initY:Number;
		private var volumeSon:Number;
		private var changeVolume:SoundTransform;
        private var seConnecter:NetConnection ;
		private var url:String;
        // La classe LecteurVideo reprend les fonctionnalités du lecteur vidéo 
		// décrit au cours du chapitre 10, section Un lecteur de vidéo
		public function LecteurVideo( nom:String) {
			if (controleur != null) removeChild(controleur);
			controleur = new ControleurClp();
			url = nom;
			// Créer un objet Video
			seConnecter = new NetConnection();
			seConnecter.addEventListener(NetStatusEvent.NET_STATUS, quelleConnection);
			// Création d'une connection locale streamée
			seConnecter.connect(null);	
			
		}
		
		public function remiseAZero():void {
			// Le controleur est initialisé :
			//   - Le bouton Lecture est affiché, 
			//   - Les boutons Pause et Stop sont effacés
			//   - La barre de progression est remise à 0
			//   - Le son est arrêté
			unFlux.pause();
			unFlux.seek(0);
			controleur.lire.visible = true;
			controleur.faireUnePause.visible = false;
			controleur.curseur.gotoAndStop("normal");
			controleur.stopper.visible=false;
			if ( controleur.bulleProgress != null) {
				controleur.bulleProgress.removeEventListener(Event.ENTER_FRAME, barreProgresse);
			}
			controleur.bulleProgress.scaleX=0.01;
		}

		private function siErreur(e:AsyncErrorEvent):void {
			//trace(e);
		}
		private function quelleConnection(event:NetStatusEvent):void {
			switch (event.info.code) {
				case "NetConnection.Connect.Success" :
					creerUnFlux();
					break;
				case "NetStream.Play.StreamNotFound" :
					trace(" Fichier vidéo non trouvé : " + url);
					break;
			}
		}
		
		private function creerUnFlux():void {			
			unFlux = new NetStream(seConnecter);
			unFlux.addEventListener(AsyncErrorEvent.ASYNC_ERROR, siErreur);
			unFlux.play(url);
			unFlux.pause();
			unFlux.addEventListener(NetStatusEvent.NET_STATUS, quelStatus);
			afficherControleur();
		}
		private  function afficherControleur() {
			//  Initialisation du controleur
			
			addChild(controleur);
			var ecran:Video = new Video();
			ecran.attachNetStream(unFlux);
			controleur.addChild(ecran);
			ecran.x = -controleur.width/3 + 10;
			ecran.y = -controleur.height/3 + 10;
			remiseAZero();
			// Le bouton Lecture
			controleur.lire.addEventListener(MouseEvent.CLICK, pourLire);
			// Le bouton Pause
			controleur.faireUnePause.addEventListener(MouseEvent.MOUSE_UP, pourFaireUnePause);
			// Le bouton Stopper
			controleur.stopper.addEventListener(MouseEvent.MOUSE_UP, pourStopper);
			gererLeSon();
		}
		private function gererLeSon() {
			// Gestion du volume sonore
			initX = controleur.niveau.x;
			initY = controleur.niveau.y;
			changeVolume = new SoundTransform(1, 0);
			volumeSon = changeVolume.volume;
			var longueur:Number = controleur.niveau.width;
			// Positionner le curseur du volume en fonction du volume sonore du mp3
			controleur.curseur.x =  initX + longueur *volumeSon - controleur.curseur.width;
			controleur.curseur.y = initY ;
			controleur.curseur.buttonMode = true;
			//controleur.curseur.addEventListener(MouseEvent.MOUSE_UP, auRelachement);
			addEventListener(MouseEvent.MOUSE_UP, auRelachement);

			// Modifier l'apparence du curseur du volume en fonction de la position du curseur
			controleur.curseur.addEventListener(MouseEvent.MOUSE_OVER, auSurvol);
			controleur.curseur.addEventListener(MouseEvent.MOUSE_OUT, alExterieur);
			controleur.curseur.addEventListener(MouseEvent.MOUSE_DOWN, auPress);
        }

		private function quelStatus(e:NetStatusEvent):void {
			switch (e.info.code) {
				case "NetStream.Play.Stop" :
					remiseAZero();
					break;
			}
		}

		private function barreProgresse(e:Event):void {
			var tempsTotal:Number=70;
			controleur.bulleProgress.scaleX = unFlux.time/tempsTotal;
		}


		private function pourLire(e:MouseEvent):void {
			controleur.stopper.visible = true;
			controleur.faireUnePause.visible = true;
			controleur.lire.visible = false;
			unFlux.resume();
			controleur.bulleProgress.addEventListener(Event.ENTER_FRAME, barreProgresse);
		}

		private function pourFaireUnePause(e:MouseEvent):void {
			unFlux.pause();
			controleur.lire.visible = true;
			controleur.faireUnePause.visible = false;
			controleur.stopper.visible = true;
		}
		private function pourStopper(e:MouseEvent):void {
			remiseAZero();
		}

		private function auSurvol(e:MouseEvent):void {
			controleur.curseur.gotoAndStop("survol");
		}

		private function alExterieur(e:MouseEvent):void {
			controleur.curseur.gotoAndStop("normal");
			controleur.curseur.stopDrag();
			removeEventListener(MouseEvent.MOUSE_MOVE, auDeplacement);
		}


		private function auPress(e:MouseEvent):void {
			var longueur:Number = controleur.niveau.width;
			var zoneDeplacement:Rectangle = new Rectangle(initX,initY,longueur - controleur.curseur.width, 0);
			controleur.curseur.startDrag(false, zoneDeplacement);
			controleur.curseur.gotoAndStop("clique");
			controleur.curseur.addEventListener(MouseEvent.MOUSE_MOVE, auDeplacement);

		}
		private function auDeplacement(e:MouseEvent):void {
			var longueur:Number = controleur.niveau.width;
			volumeSon =  (controleur.curseur.x -initX)/longueur;
			changeVolume.volume = volumeSon;
			unFlux.soundTransform = changeVolume;
		}

		// Arrêter le déplacement du curseur du volume
		private function auRelachement(e:MouseEvent):void {
			controleur.curseur.gotoAndStop("normal");
			controleur.curseur.stopDrag();
			controleur.curseur.removeEventListener(MouseEvent.MOUSE_MOVE, auDeplacement );
		}
	
	}
	
	
	
}